import { Component, createSignal } from 'solid-js';

import { JSX } from 'solid-js';
import Page from './Page';

const StrRev: Component = () => {
	const [output, setOutput] = createSignal('');

	const onChange: JSX.EventHandler<HTMLTextAreaElement, InputEvent> = (event) => {
		setOutput(event.currentTarget.value.split('').reverse().join(''));
	};

	let outputField: HTMLInputElement | undefined;

	const copy = async () => {
		outputField!.select();
		document.execCommand('copy');
	};

	return (
		<Page title={'String Noise'}>
			<h2>Input</h2>
			<textarea oninput={onChange} />
			<h2>Output</h2>
			<input value={output()} ref={outputField} />
			<button onclick={copy}>Copy Output</button>
		</Page>
	);
};

export default StrRev;
