function murmurHash3(string: string) {
	let i = 0, hash: number;
	for (hash = 1779033703 ^ string.length; i < string.length; i++) {
		const bitwise_xor_from_character = hash ^ string.charCodeAt(i);
		hash = Math.imul(bitwise_xor_from_character, 3432918353);
		hash = hash << 13 | hash >>> 19;
	}
	return () => {
		// Return the hash that you can use as a seed
		hash = Math.imul(hash ^ (hash >>> 16), 2246822507);
		hash = Math.imul(hash ^ (hash >>> 13), 3266489909);
		return (hash ^= hash >>> 16) >>> 0;
	};
}

function simpleFastCounter32(seed_1: number, seed_2: number, seed_3: number, seed_4: number) {
	return () => {
		seed_1 >>>= 0;
		seed_2 >>>= 0;
		seed_3 >>>= 0;
		seed_4 >>>= 0;
		let cast32 = (seed_1 + seed_2) | 0;
		seed_1 = seed_2 ^ seed_2 >>> 9;
		seed_2 = seed_3 + (seed_3 << 3) | 0;
		seed_3 = (seed_3 << 21 | seed_3 >>> 11);
		seed_4 = seed_4 + 1 | 0;
		cast32 = cast32 + seed_4 | 0;
		seed_3 = seed_3 + cast32 | 0;
		return (cast32 >>> 0) / 4294967296;
	};
}

export function createRandomGenerator(seed: string) {
	const seedGenerator = murmurHash3(seed);
	return simpleFastCounter32(seedGenerator(), seedGenerator(), seedGenerator(), seedGenerator());
}
